###############################################################################
# WhoPost.pl                                                                  #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.1                                                    #
# Released:       November 8, 2005                                            #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2005 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################


LoadLanguage("WhoPost");


sub WhoPost {
	
	$headers .= "Content-type: text/html\n";
	if ($yySetCookies) { $headers .= $yySetCookies; }
	$headers .= "\n";
	print $headers;

	my $viewnum = $INFO{'tp'} || 0;

	if (!$viewnum) { exit; }

	my $counter = 0;
	my (@messages, @buffer, $buffer, $output, $membername, $topicname);
	my %top_list = ();

	fopen(MSGTXT, "$datadir/$viewnum.txt") || &fatal_error("cannot_open","$datadir/$viewnum.txt", 1);
	@buffer = <MSGTXT>;
	fclose(MSGTXT);
	($topicname, undef) = split(/\|/, $buffer[0]);
	 foreach $buffer (@buffer) {
		(undef, undef, undef, undef, $membername, undef) = split(/\|/, $buffer);
		$top_list{$membername} = $top_list{$membername} + 1;
	}
	undef @buffer;

	my @top_list = sort { $top_list{$b} <=> $top_list{$a} } keys %top_list;
	my $usercount = @top_list;

	my $postdisplaynum = 8;
	my $userdisplaynum = 10;
	my $max = $usercount;
	my $pstart = $INFO{'pstart'} || 0;
	$pstart = ( int( $pstart / $userdisplaynum ) ) * $userdisplaynum;
	$tmpa = 1;
	$tmpx = int( $max / $userdisplaynum );
	if ($pstart >= (($postdisplaynum-1) * $userdisplaynum)) { $startpage = $pstart - (($postdisplaynum-1) * $userdisplaynum); $tmpa = int( $startpage / $userdisplaynum ) + 1; }
	if ($max >= $pstart + ($postdisplaynum * $userdisplaynum)) { $endpage = $pstart + ($postdisplaynum * $userdisplaynum); } else { $endpage = $max }
	if ($startpage > 0) { $pageindex = qq~<a href="$scripturl?action=whopost;tp=$viewnum;pstart=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $userdisplaynum) { $pageindex = qq~<a href="$scripturl?action=whopost;tp=$viewnum;pstart=0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $userdisplaynum ) {
		$pageindex .= $pstart == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$scripturl?action=whopost;tp=$viewnum;pstart=$counter">$tmpa</a>&nbsp;~;
		$tmpa++;
	}
	$tmpx = $max - $userdisplaynum;
	$outerpn = int($tmpx / $userdisplaynum) + 0;
	$lastpn = int($countrepa / $userdisplaynum) + 1;
	$lastptn = ($lastpn - 1) * $userdisplaynum;
	if ($endpage < $max - ($userdisplaynum) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~&nbsp;<a href="$scripturl?action=whopost;tp=$viewnum;pstart=$lastptn">$lastpn</a>~;}
	$pageindex .= $pageindexadd;

my $output = qq~
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
	<title>$whptxt{'01'}</title>
	<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />
	</head>
	<body>
	<script language="JavaScript1.2" type="text/javascript">
	<!-- 
	function opp_topic(tid){
		opener.location= "$scripturl?num=" + tid;
		self.close();
	}
	//-->
	</script>
	<table border="0" cellpadding="4" cellspacing="1" width="100%" class="bordercolor">
	<tr>
		<td class="titlebg" align="center" colspan="2"><b>$whptxt{'02'} <i>$topicname</i></b></td>
	</tr>
	<tr>
		<td class="catbg" colspan="2">&nbsp;
	~;
	
	if ($usercount > $userdisplaynum ) {
		$output .= qq~<b>$whptxt{'03'}</b> $pageindex~;
	}
		
	$output .= qq~
		</td>
	</tr>
	<tr>
		<td width="70%" class="windowbg"><b>$whptxt{'04'}</b></td>
		<td width="30%" align="center" class="windowbg"><b>$whptxt{'05'}</b></td>
	</tr>
	~;

	my $i = 0;
	my $i2 = 0;
	foreach $member (@top_list) {
		if ($i2 < $pstart) { $i2++; next; }
		if (!${$uid.$member}{'password'}) { &LoadUser($member); }
		my $mname = "";
		if ($member ne 'Guest') {
			unless(${$uid.$member}{'regdate'} || ${$uid.$member}{'status'} eq "Administrator" || ${$uid.$member}{'status'} eq "Global Moderator") {
				$mname = qq~<nobr>$member - ($whptxt{'07'})</nobr>~;
			} else {
				$mname = qq~$link2{$member}~;
			}
		} else {
				$mname = qq~$member~;
		}
		
		$output .= qq~
		<tr>
			<td class="windowbg2">$mname</td>
			<td class="windowbg2" align="center">$top_list{$member}</td>
		</tr>
		~;
	$i++;
	$i2++;
	if ($i == $userdisplaynum) { last; }
	}
	
	$output .= qq~
	<tr>
		<td class="catbg" colspan="2">&nbsp;
	~;

	if ($usercount > $userdisplaynum ) {
		$output .= qq~<b>$whptxt{'03'}</b> $pageindex~;
	}

	$output .= qq~
	<tr>
		<td colspan="2" class="windowbg" align="center"><a href="javascript:opp_topic($viewnum);">$whptxt{'06'}</a></td>
	</tr>
	</table>
	</body>
	</html>
	~;
	undef %top_list;

if ($gzcomp && $gzaccept) {
	if ($gzcomp == 1) {
		$| = 1;
		open(GZIP, "| gzip -f");
		print GZIP $output;
		close(GZIP);
	} else {
		require Compress::Zlib;
		binmode STDOUT;
		print Compress::Zlib::memGzip($output);
	}
} else {
	print $output;
}

exit;
}

1;
